% This script times GSYLV_MERGE for a range of minimal blocksizes NMIN.
% It reproduces results shown in the technical report
% Recursive blocked algorithms for linear systems with Kronecker product structure

nmin_range3 = 3:30;

d = 3;
nn = 80;
samples = 5;

n = nn*ones(1,d);
for i = 1:d, A{i} = randn(n(i)); end
C = randn( n(1) );
B = randn(n);

timed3 = [];
for nmin = nmin_range3,
    nmin
    t = 0;
    for s = 1:samples,
       tic
       X = gsylv_merge( A, B, C, nmin );
       t = t+toc;
    end
    timed3 = [timed3;t/samples];
    timed3(end)
end


nmin_range4 = 3:30;

d = 4;
nn = 25;
samples = 5;

n = nn*ones(1,d);
for i = 1:d, A{i} = randn(n(i)); end
C = randn( n(1) );
B = randn(n);

timed4 = [];
for nmin = nmin_range4,
    nmin
    t = 0;
    for s = 1:samples,
       tic
       X = gsylv_merge( A, B, C, nmin );
       t = t+toc;
    end
    timed4 = [timed4;t/samples];
    timed4(end)
end

plot( nmin_range3, timed3, 'r--')
hold on
plot( nmin_range4, timed4, 'r-')
legend('d = 3', 'd = 4', 'Location', 'NorthEast')
hold off
