function r = gsylv_residual(A,B,C,X)
% GSYLV_RESIDUAL( A, B, C, X ) returns the Frobenius norm of 
%  X x_1 A{1} + X x_1 C x_2 A{2} ... x_d A{d} - B.

n = size(B); d = length(n);
r = -B;

Y = X;
Y = A{1}*reshape( Y, n(1), prod( n( 2:d ) ) );
Y = reshape( Y, n(1:d) );
r=r+Y;

A{1}=C;
for i = 1:d
    order = [i, 1:i-1, i+1:d];
    X = permute(X,order);
    X = A{i}*reshape( X, n(i), prod( n( order(2:d) ) ) );
    X = reshape( X, n(order) ); X = ipermute(X,order); 
end

r = r + X;
r = norm(r(:));