function r = laplace_residual( A, B, X )
% LAPLACE_RESIDUAL( A, B, X ) returns the Frobenius norm of 
% X x_1 A{1} + ... + X x_d A{d} - B.

n = size(B); d = length(n);
r = -B;
for i = 1:d,
    order = [i, 1:i-1, i+1:d];
    Y = permute(X,order);
    Y = A{i}*reshape( Y, n(i), prod( n( order(2:d) ) ) );
    Y = reshape( Y, n(order) ); Y = ipermute(Y,order);
    r = r + Y;
end
r = norm(r(:));
