function X = laplace_small( A, B )
% LAPLACE_SMALL( A, B ) computes the solution of the Laplace equation
%   X x_1 A{1} + ... + X x_d A{d} = B.
% The usefulness of this function is restricted to small orders/sizes.

  n = size(B); d = length(n);
  if prod(n) > 10000, error('Matrix too large'); end
  K = zeros(prod(n));
  
  nn = prod(n(2:end));
  K = kron(eye(nn), A{1} );  
  for i = 2:d-1,
      K = K + kron( kron(eye(prod(n(i+1:end))),A{i}), eye(prod(n(1:i-1))));
  end
  nn = prod(n(1:d-1));
  K = K + kron( A{d}, eye(nn) );    
  
  X = B;
  X(:) = K \ B(:);
