% Sanity check that all functions for generalized Sylvester equations work well

d = 3;
n = 10*ones(1,d);
for i = 1:d, A{i} = randn(n(i)); end
C = randn( n(1) );
B = randn( n );

X = gsylv_small( A, B, C );
fprintf('Residual for GSYLV_SMALL = %g\n', gsylv_residual( A, B, C, X ) )

X = gsylv_recursive( A, B, C );
fprintf('Residual for GSYLV_RECURSIVE = %g\n', gsylv_residual( A, B, C, X ) )

X = gsylv_merge( A, B, C );
fprintf('Residual for GSYLV_MERGE = %g\n', gsylv_residual( A, B, C, X ) )
