% Sanity check that all functions for Laplace-like equations work well

d = 3;
n = 10*ones(1,d);
for i = 1:d, A{i} = randn(n(i)); end
B = randn(n);

X = laplace_small(A,B);
fprintf('Residual for LAPLACE_SMALL = %g\n', laplace_residual( A, B, X ) )

X = laplace_recursive(A,B);
fprintf('Residual for LAPLACE_RECURSIVE = %g\n', laplace_residual( A, B, X ) )

X = laplace_merge(A,B);
fprintf('Residual for LAPLACE_MERGE = %g\n', laplace_residual( A, B, X ) )
